using LinqToDB.Data;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Hosting;
using RTMPDash.DataModels;

namespace RTMPDash {
	public class Program {
		public const string SiteName       = "zotan.stream";
		public const string IngressDomain  = "rtmp://zotan.stream";
		public const string RootDomain     = "https://zotan.stream";
		public const string PlayerDomain   = "https://live.on.zotan.stream";
		public const string FragmentDomain = "https://cdn.zotan.stream";
		public const string StatsDomain    = "https://stats.zotan.stream";
		public const string PrivacyEmail   = "stream-privacy@zotan.email";
		public const string CopyrightEmail = "stream-copyright@zotan.email";
		public const string AbuseEmail     = "stream-abuse@zotan.email";

		public static void Main(string[] args) {
			DataConnection.DefaultSettings = new AppDb.Settings();
			CreateHostBuilder(args).Build().Run();
		}

		public static IHostBuilder CreateHostBuilder(string[] args) => Host.CreateDefaultBuilder(args)
																		   .ConfigureWebHostDefaults(webBuilder => {
																			   webBuilder.UseStartup<Startup>();
																		   });
	}
}